Loading...
Searching...
No Matches
gtsam::DoglegOptimizer Class Reference

## Detailed Description

This class performs Dogleg nonlinear optimization.

Inheritance diagram for gtsam::DoglegOptimizer:

## Public Member Functions

Standard interface
| DoglegOptimizer (const NonlinearFactorGraph &graph, const Values &initialValues, const DoglegParams &params=DoglegParams())
| Standard constructor, requires a nonlinear factor graph, initial variable assignments, and optimization parameters.
| DoglegOptimizer (const NonlinearFactorGraph &graph, const Values &initialValues, const Ordering &ordering)
| Standard constructor, requires a nonlinear factor graph, initial variable assignments, and optimization parameters.
Advanced interface
| ~DoglegOptimizer () override
| Virtual destructor.
GaussianFactorGraph::shared_ptr | iterate () override
| Perform a single iteration, returning GaussianFactorGraph corresponding to the linearized factor graph.
const DoglegParams & | params () const
| Read-only access the parameters.
double | getDelta () const
| Access the current trust region radius delta.
Public Member Functions inherited from gtsam::NonlinearOptimizer
virtual const Values & | optimize ()
| Optimize for the maximum-likelihood estimate, returning a the optimized variable assignments.
const Values & | optimizeSafely ()
| Optimize, but return empty result if any uncaught exception is thrown Intended for MATLAB.
double | error () const
| return error in current optimizer state
size_t | iterations () const
| return number of iterations in current optimizer state
const Values & | values () const
| return values in current optimizer state
const NonlinearFactorGraph & | graph () const
| return the graph with nonlinear factors
virtual | ~NonlinearOptimizer ()
| Virtual destructor.
virtual VectorValues | solve (const GaussianFactorGraph &gfg, const NonlinearOptimizerParams &params) const
| Default function to do linear solve, i.e.

## Public Types

typedef boost::shared_ptr< DoglegOptimizer > | shared_ptr
Public Types inherited from gtsam::NonlinearOptimizer
using | shared_ptr = boost::shared_ptr<const NonlinearOptimizer>
| A shared pointer to this class.

## Protected Member Functions

const NonlinearOptimizerParams & | _params () const override
| Access the parameters (base class version).
DoglegParams | ensureHasOrdering (DoglegParams params, const NonlinearFactorGraph &graph) const
| Internal function for computing a COLAMD ordering if no ordering is specified.
Protected Member Functions inherited from gtsam::NonlinearOptimizer
void | defaultOptimize ()
| A default implementation of the optimization loop, which calls iterate() until checkConvergence returns true.
| NonlinearOptimizer (const NonlinearFactorGraph &graph, std::unique_ptr< internal::NonlinearOptimizerState > state)
| Constructor for initial construction of base classes.

## Protected Attributes

DoglegParams | params_
Protected Attributes inherited from gtsam::NonlinearOptimizer
NonlinearFactorGraph | graph_
| The graph with nonlinear factors.
std::unique_ptr< internal::NonlinearOptimizerState > | state_
| PIMPL'd state.

## Constructor & Destructor Documentation

## DoglegOptimizer() [1/2]

gtsam::DoglegOptimizer::DoglegOptimizer | ( | const NonlinearFactorGraph & | graph,
|  | const Values & | initialValues,
|  | const DoglegParams & | params = DoglegParams() )

Standard constructor, requires a nonlinear factor graph, initial variable assignments, and optimization parameters.

For convenience this version takes plain objects instead of shared pointers, but internally copies the objects.

Parameters

  graph | The nonlinear factor graph to optimize
  initialValues | The initial variable assignments
  params | The optimization parameters

## DoglegOptimizer() [2/2]

gtsam::DoglegOptimizer::DoglegOptimizer | ( | const NonlinearFactorGraph & | graph,
|  | const Values & | initialValues,
|  | const Ordering & | ordering )

Standard constructor, requires a nonlinear factor graph, initial variable assignments, and optimization parameters.

For convenience this version takes plain objects instead of shared pointers, but internally copies the objects.

Parameters

  graph | The nonlinear factor graph to optimize
  initialValues | The initial variable assignments

## Member Function Documentation

## _params()

const NonlinearOptimizerParams & gtsam::DoglegOptimizer::_params | ( |  | ) | const

inline override protected virtual

Access the parameters (base class version).

Implements gtsam::NonlinearOptimizer.

## iterate()

GaussianFactorGraph::shared_ptr gtsam::DoglegOptimizer::iterate | ( | void |  | ) |

override virtual

Perform a single iteration, returning GaussianFactorGraph corresponding to the linearized factor graph.

Implements gtsam::NonlinearOptimizer.

The documentation for this class was generated from the following files:

- /build/gtsam-gchP9J/gtsam-4.2.2+dfsg/gtsam/nonlinear/DoglegOptimizer.h
- /build/gtsam-gchP9J/gtsam-4.2.2+dfsg/gtsam/nonlinear/DoglegOptimizer.cpp